import { Component, OnInit, ViewChild } from '@angular/core';
import { Router } from '@angular/router';
import { STComponent, STColumn, STChange } from '@delon/abc/st';
import { SFComponent, SFSchema, SFDateWidgetSchema } from '@delon/form';
import { NzModalService } from 'ng-zorro-antd/modal';
import { SystemService } from 'src/app/routes/sys-setting/services/system.service';

@Component({
  selector: 'app-driver-account',
  templateUrl: './driver-account.component.html',
  styleUrls: ['./driver-account.component.less']
})
export class DriverAccountComponent implements OnInit {
  @ViewChild('st', { static: true })
  st!: STComponent;
  @ViewChild('sf', { static: false })
  sf!: SFComponent;

  url = `/rule?_allow_anonymous=true`;

  searchSchema: SFSchema = {
    properties: {
      expand: {
        type: 'boolean',
        ui: {
          hidden: true
        }
      },
      receiveName: {
        type: 'string',
        title: '司机姓名',
        ui: { placeholder: '请输入' }
      },
      phone: {
        type: 'string',
        title: '证件号码',
        ui: { placeholder: '请输入' }
      },
      page: {
        type: 'string',
        title: '手机号',
        ui: {
          placeholder: '请输入'
        }
      },
      createTime: {
        title: '创建时间',
        type: 'string',
        ui: {
          widget: 'date',
          mode: 'range',
          format: 'yyyy-MM-dd',
          visibleIf: {
            expand: (value: boolean) => value
          }
        } as SFDateWidgetSchema
      }
    }
  };

  columns: STColumn[] = [
    { title: '司机姓名', index: 'description' },
    { title: '证件号码', index: 'description' },
    { title: '手机号', index: 'description' },
    { title: '账户余额', index: 'description' },
    { title: '油卡余额', index: 'description' },
    { title: '创建时间', index: 'updatedAt', type: 'date' },
    {
      title: '操作',
      buttons: [
        {
          text: '查看明细',
          click: item => this.routeTo(item)
        }
      ]
    }
  ];
  reqParams = { pageIndex: 1, pageSize: 10 };
  _$expand = false;

  constructor(public service: SystemService, private router: Router) {}

  ngOnInit(): void {}

  stChange(e: STChange): void {
    switch (e.type) {
      case 'filter':
        this.st.load();
        break;
    }
  }

  routeTo(item?: any) {
    this.router.navigate(['/financial-management/driver-account-detail/1']);
  }

  /**
   * 重置表单
   */
  resetSF() {
    this.sf.reset();
    this._$expand = false;
  }

  /**
   * 伸缩查询条件
   */
  expandToggle() {
    this._$expand = !this._$expand;
    this.sf?.setValue('/expand', this._$expand);
  }
}
